package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.protocol.KeyPageOperation;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: KeyPageOperationType
// UnionValue: UpdateAllowed

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("UpdateAllowedKeyPageOperation")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class UpdateAllowedKeyPageOperation implements KeyPageOperation {
	public final KeyPageOperationType type = KeyPageOperationType.UPDATE_ALLOWED;
	private TransactionType[] allow;
	private TransactionType[] deny;

    //
	public TransactionType[] getAllow() {
	    return allow;
	}
	public void setAllow(final TransactionType[] value) {
	    this.allow = value;
	}

	public UpdateAllowedKeyPageOperation allow(final TransactionType[] value) {
	    setAllow(value);
	    return this;
	}
	public TransactionType[] getDeny() {
	    return deny;
	}
	public void setDeny(final TransactionType[] value) {
	    this.deny = value;
	}

	public UpdateAllowedKeyPageOperation deny(final TransactionType[] value) {
	    setDeny(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.allow == null)) {
            marshaller.writeValue(2, allow);
        }
        if (!(this.deny == null)) {
            marshaller.writeValue(3, deny);
        }
        return marshaller.array();
    }
}
